import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class TypeSplitter {
    private String text;
    private List<Integer> tokenTypesCount = new ArrayList<>();
    private Map<String, Integer> wordCount = new HashMap<>();
    private List<String> tokens = new ArrayList<>();
    public TypeSplitter(String text) {


        for (int i = 0; i < TokenType.values().length; i++) tokenTypesCount.add(0);

        StringBuilder sb = new StringBuilder(text);
        CreateToken ct = new CreateToken();

        // Vypíšeme počet tokenov jednotlivých typov
        for (int i = 0; i < tokenTypesCount.size(); i++) {
            System.out.println("Token type " + TokenType.values()[i] + ": " + tokenTypesCount.get(i));
        }
        for (int i = 0; i < sb.length(); i++) {
            if (ct.addChar(sb.charAt(i))) {
                // Ak sa podarilo pridať znak, pokračuj
            } else {
                // Ak nie, token je hotový
                //System.out.print(ct.getToken() + " | Type: " + ct.getTokenType());
                tokenTypesCount.set(ct.getTokenType().getValue(), tokenTypesCount.get(ct.getTokenType().getValue()) + 1);
                //System.out.println(" | Count: " + tokenTypesCount.get(ct.getTokenType().getValue()));
                //System.out.println("Setting: " + ct.getTokenType().getValue() + " val: " + tokenTypesCount.get(ct.getTokenType().getValue()) + 1);

                String token = ct.getToken();
                if (ct.getTokenType() == TokenType.WORD) {
                    token = token.toLowerCase(); // zmení iba slová na malé písmená
                }
                tokens.add(token);
                if (wordCount.containsKey(token)) {
                    wordCount.put(token, wordCount.get(token) + 1);
                } else {
                    wordCount.put(token, 1);
                }
                ct.reset();
                i--;
            };

        }

        // Vypíšeme počet tokenov jednotlivých typov
        for (int i = 0; i < tokenTypesCount.size(); i++) {
            System.out.println("Token type " + TokenType.values()[i] + ": " + tokenTypesCount.get(i));
        }
        // Vypíšeme počet výskytov jednotlivých slov
        /*System.out.println("Word count:");
        for (Map.Entry<String, Integer> entry : wordCount.entrySet()) {
            System.out.println(entry.getKey() + ": " + entry.getValue());
        }*/

    }
    public List<Integer> getTokenTypesCount() {
        return tokenTypesCount;
    }
    public Map<String, Integer> getWordCount() {
        return wordCount;
    }

    public Map<String, Integer> getNeighborCount(List<String> tokens) {
        Map<String, Integer> neighborCount = new HashMap<>();

        for (int i = 0; i < tokens.size()-1; i++) {
            // Skontrolujeme, či je token biely znak, alebo prázdny
            if (tokens.get(i).trim().isEmpty() || tokens.get(i + 1).trim().isEmpty()) {
                continue; // Ignorujeme biele znaky
            }
            String token = "<" + tokens.get(i) + ">_<" + tokens.get(i + 1) + ">";
            // Zvýšime počet výskytov tokenu
            if (neighborCount.containsKey(token)) {
                neighborCount.put(token, neighborCount.get(token) + 1);
            } else {
                neighborCount.put(token, 1);
            }
        }

        return neighborCount;
    }

    public String printNeighborCount() {
        StringBuilder sb = new StringBuilder();
        for (Map.Entry<String, Integer> entry : getNeighborCount(getTokensWithoutWhiteSpace()).entrySet()) {
            sb.append(entry.getKey()).append(": ").append(entry.getValue()).append("\n");
        }
        return sb.toString();
    }
    public String printNeighborCountSortedByValue() {
        StringBuilder sb = new StringBuilder();
        Map<String, Integer> neighborCount = getNeighborCount(getTokensWithoutWhiteSpace());
        neighborCount.entrySet().stream()
                .sorted(Map.Entry.<String, Integer>comparingByValue().reversed())
                .forEach(entry -> sb.append(entry.getKey()).append(": ").append(entry.getValue()).append("\n"));
        return sb.toString();
    }
    public String printNeighborCountSortedByKey() {
        StringBuilder sb = new StringBuilder();
        Map<String, Integer> neighborCount = getNeighborCount(getTokensWithoutWhiteSpace());
        neighborCount.entrySet().stream()
                .sorted(Map.Entry.comparingByKey())
                .forEach(entry -> sb.append(entry.getKey()).append(": ").append(entry.getValue()).append("\n"));
        return sb.toString();
    }
    public List<String> getTokens() {
        return tokens;
    }
    public List<String> getTokensWithoutWhiteSpace() {
        List<String> tokensWithoutWhiteSpace = new ArrayList<>();
        for (String token : tokens) {
            if (!token.trim().isEmpty()) {
                tokensWithoutWhiteSpace.add(token);
            }
        }
        return tokensWithoutWhiteSpace;
    }
}
